//
//  AppDelegate.m
//  TMLauncher
//
//  Created by Pravin on 7/8/16.
//  Copyright © 2016 RHUB Communication Inc. All rights reserved.
//

#import "AppDelegate.h"

@interface AppDelegate ()

@property (weak) IBOutlet NSWindow *window;
@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
    // Insert code here to tear down your application
}

- (IBAction)OnHostMeetingButtonClick:(id)sender
{
    NSString *sServerPort = @"80";
    NSString *sEmailAddress = [m_oEmailAddressTextField stringValue];
    NSString *sUserPassword = [m_oPasswordTextField stringValue];
    NSString *sServerAddress = [m_oHostServerAddressTextField stringValue];
    NSString *sOEMID = [m_oHostOEMIDTextField stringValue];
    
    NSString *sFileContent = @"<Action>Host</Action>\n";
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<ServerAddress>%@</ServerAddress>\n", sServerAddress]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<ServerPort>%@</ServerPort>\n", sServerPort]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingPassword></MeetingPassword>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingId></MeetingId>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<AttendeeName></AttendeeName>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<Email>%@</Email>\n", sEmailAddress]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<UserPassword>%@</UserPassword>\n", sUserPassword]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingType>0</MeetingType>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<StartMeetingNow>Y</StartMeetingNow>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<StartAtMinimized>N</StartAtMinimized>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<Caller>%@</Caller>\n", sOEMID]];
    
    [self ExecuteCommnand:sFileContent];
}

- (IBAction)OnJoinMeetingButtonClick:(id)sender
{
    NSString *sEmailAddress;
    NSString *sServerPort = @"80";
    NSString *sMeetingID = [m_oMeetingIDTextField stringValue];
    NSString *sMeetingPassword = [m_oMeetingPasswordTextField stringValue];
    NSString *sYourName = [m_oYourNameTextField stringValue];
    NSString *sServerAddress = [m_oJoinServerAddressTextField stringValue];
    NSString *sOEMID = [m_oJoinOEMIDTextField stringValue];
    
    NSString *sFileContent = @"<Action>Join</Action>\n";
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<ServerAddress>%@</ServerAddress>\n", sServerAddress]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<ServerPort>%@</ServerPort>\n", sServerPort]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingPassword>%@</MeetingPassword>\n", sMeetingPassword]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingId>%@</MeetingId>\n", sMeetingID]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<AttendeeName>%@</AttendeeName>\n", sYourName]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<Email>%@</Email>\n", sEmailAddress]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<UserPassword></UserPassword>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<MeetingType></MeetingType>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<StartMeetingNow>Y</StartMeetingNow>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<StartAtMinimized>Y</StartAtMinimized>\n"]];
    sFileContent = [sFileContent stringByAppendingString:[NSString stringWithFormat:@"<Caller>%@</Caller>\n", sOEMID]];
    
    [self ExecuteCommnand:sFileContent];
}

- (void) ExecuteCommnand:(NSString *)sFileContent
{
    NSString *sTMApplicationPath = [self GetApplicationPath];
    NSString *sTMExecutablePath = [[NSBundle bundleWithPath:sTMApplicationPath] executablePath];
    NSString *sFilePath = [sTMApplicationPath stringByAppendingString:@"/TMLauncher.txt"];
    [[NSFileManager defaultManager] createFileAtPath:sFilePath contents:nil attributes:nil];
    [sFileContent writeToFile:sFilePath atomically:YES encoding:NSUTF8StringEncoding error:nil];
    
    NSTask *oCommandLineTask = [[NSTask alloc] init];
    oCommandLineTask.launchPath = sTMExecutablePath;
    oCommandLineTask.arguments = @[@"--cmd", sFilePath];
    [oCommandLineTask launch];
    
    //NSString *sCommandLine = [NSString stringWithFormat:@"exec %@ --cmd %@ &", sTMExecutablePath, sFilePath];
    //system([sCommandLine UTF8String]);*/
}

- (NSString *) GetApplicationPath
{
    NSString *sPropertyFile = [@"~/.TurboMeeting/TurboMeeting.property" stringByExpandingTildeInPath];
    if([[NSFileManager defaultManager] fileExistsAtPath:sPropertyFile])
    {
        NSData *oData = [NSData dataWithContentsOfURL:[NSURL fileURLWithPath:sPropertyFile]];
        NSString *sValue = [NSString stringWithUTF8String:(const char*)[oData bytes]];
        
        NSRange oPrefixInstance = [sValue rangeOfString:@"<__ClientDirectory__>"];
        NSRange oSuffixInstance = [sValue rangeOfString:@"</__ClientDirectory__>"];
        
        NSUInteger iStartPoint = oPrefixInstance.location + oPrefixInstance.length;
        NSUInteger iEndPoint = oSuffixInstance.location - iStartPoint;
        NSRange needleRange = NSMakeRange(iStartPoint, iEndPoint);
        NSString *sApplicationPath = [sValue substringWithRange:needleRange];
        
        return sApplicationPath;
    }
    
    return @"";
}

@end
